
#ifndef __SPIKE_SYSTEM_H
#define __SPIKE_SYSTEM_H

#include "Spike.h"
#include "SpikeRule.h"
#include "../lsystem/LSystem.h"
#include "../util/Random.h"


class CSpikeSystem {
public:
	enum { RULE_VARS = 4 };
	typedef CLSystem<CSpike,CSpikeRule,RULE_VARS> TSpikeSystem;
public:
	/** Singleton. */
	static CSpikeSystem& getInstance();

	const TSpikeSystem& getSystem() const { return *mSystem; }
	TSpikeSystem& getSystem() { return *mSystem; }

	const TSpikeSystem::TRuleVector& getRules( int var ) const { return mRules[var]; }
	TSpikeSystem::TRuleVector& getRules( int var ) { return mRules[var]; }

	const CRandom& getRandom() const { return mRandom; }
	CRandom& getRandom() { return mRandom; }
	
protected:
	CSpikeSystem();

private:
	static CSpikeSystem* mSingleInstance;

	TSpikeSystem*	mSystem;
	TSpikeSystem::TRuleVector* mRules;
	CRandom			mRandom;
};



#endif
