
#ifndef __SHOW_FLAKE_BUILDER_H
#define __SHOW_FLAKE_BUILDER_H

#include "Builder.h"


class CSnowFlakeBuilder : public IBuilder {
public:
	CSnowFlakeBuilder( int initialSpikes )
		: mInitialSpikes( initialSpikes ) { }
	
	virtual void buildRules( CSpikeSystem& s );
	virtual void buildInitial( CSpikeSystem& s );
	virtual int getAllowedIterations() const { return 12; }
	
protected:
	int getInitialSpikes() const { return mInitialSpikes; }
	
private:
	int mInitialSpikes;
};

class CSnowFlakeBuilder2 : public CSnowFlakeBuilder {
public:
	CSnowFlakeBuilder2( int initialSpikes ) : CSnowFlakeBuilder( initialSpikes ) { }
	
	virtual void buildRules( CSpikeSystem& s );
	virtual int getAllowedIterations() const { return 12; }
};

class CSnowFlakeBuilder3 : public CSnowFlakeBuilder {
public:
	CSnowFlakeBuilder3( int initialSpikes ) : CSnowFlakeBuilder( initialSpikes ) { }
	
	virtual void buildRules( CSpikeSystem& s );
	virtual int getAllowedIterations() const { return 12; }
};

class CSnowFlakeBuilder4 : public CSnowFlakeBuilder {
public:
	CSnowFlakeBuilder4( int initialSpikes ) : CSnowFlakeBuilder( initialSpikes ) { }
	
	virtual void buildRules( CSpikeSystem& s );
	virtual void buildInitial( CSpikeSystem& s );
	virtual int getAllowedIterations() const { return 12; }
};

class CXmasTreeBuilder : public IBuilder {
public:
	virtual void buildRules( CSpikeSystem& s );
	virtual void buildInitial( CSpikeSystem& s );
	virtual int getAllowedIterations() const { return 8; }
};


#endif
