
#include "ToonEffects.h"


void CSingleEdgeEffect::perform( CDrawing& draw, CCanvas& color, CCanvas& depth )
{
	CCanvas::pixel*	pcolor = color.getData();
	float* pdepth = depth.getFPData();

	int n = (color.getHeight()-1) * color.getWidth() - 1;
	for( int i = 0; i < n; i++ ) {
		float diff = pdepth[color.getWidth()+1] + pdepth[color.getWidth()] + pdepth[1] - pdepth[0] * 4.0f;
		if( diff > mThreshold )
			*pcolor = mColor;
		pcolor++;
		pdepth++;
	}
}


void CShadeEffect::perform( CDrawing& draw, CCanvas& color, CCanvas& depth )
{
	CCanvas::pixel*	pcolor = color.getData();
	float* pdepth = depth.getFPData();

	float difScale = (CDrawing::TRANSPARENCY_LEVELS-1) / (mMaxDiff-mMinDiff);

	int n = (color.getHeight()-2) * color.getWidth() - 2;
	for( int i = 0; i < n; i++ ) {
		float diff = pdepth[color.getWidth()*2+2] + pdepth[color.getWidth()*2] + pdepth[2] - pdepth[0] * 3.0f;
		if( diff < mMinDiff )
			diff = mMinDiff;
		else if( diff > mMaxDiff )
			diff = mMaxDiff;
		diff -= mMinDiff;
		int alpha = (int)(diff * difScale);
		draw.pixelBlend( *pcolor, mColor, alpha );
		pcolor++;
		pdepth++;
	}
}
