
#ifndef __TOON_EFFECTS_H
#define __TOON_EFFECTS_H


#include "ImageEffect.h"


class CSingleEdgeEffect : public IImageEffect {
public:
	CSingleEdgeEffect( CCanvas::pixel color, float threshold )
		: mColor( color ), mThreshold( threshold ) { }
	virtual void perform( CDrawing& draw, CCanvas& color, CCanvas& depth );

private:
	CCanvas::pixel	mColor;
	float mThreshold;
};

class CShadeEffect : public IImageEffect {
public:
	CShadeEffect( CCanvas::pixel color, float mindiff, float maxdiff )
		: mColor( color ), mMinDiff( mindiff ), mMaxDiff( maxdiff ) { }

	virtual void perform( CDrawing& draw, CCanvas& color, CCanvas& depth );

private:
	CCanvas::pixel	mColor;
	float mMinDiff;
	float mMaxDiff;
};



#endif
