
#ifndef __RULE_H
#define __RULE_H

#include "../util/Pool.h"


/**
 *  Rule interface:
 *    float getProb() const; // return probability of rule application
 *    void apply( const SPIKE& spike, int vars, CPool<SPIKE>** pools );
 *  In apply, the rule can add new spikes to the pool (array of pools is given). After
 *  rule application, old spike is removed.
 */
template<class SPIKE>
class CBaseRule {
public:
	CBaseRule( float prob ) : mProbability( prob ) { }
	
	float getProb() const { return mProbability; }

	/** TBD. */
	/*void apply( const SPIKE& spike, int vars, CPool<SPIKE>* pools ) { }*/

private:
	float	mProbability;
};


#endif

