
#include "Vector.h"

void SVector::rotate(float rx, float ry, float rz)
{
	float sx = sinf(rx), cx = cosf(rx);
	float sy = sinf(ry), cy = cosf(ry);
	float sz = sinf(rz), cz = cosf(rz);

	float sxsy = sx * sy;
	float cxsy = cx * sy;

	float xx = x * cy*cz + y * (sxsy * cz - cx * sz) + z * (cxsy * cz + sx * sz);
	float yy = x * cy*sz + y * (sxsy * sz + cx * cz) + z * (cxsy * sz - sx * cz);
	float zz = z * (-sy) + y * (sx * cy)             + z * (cx * cy);

	set( xx, yy, zz );
}

SVector SVector::crossProduct(const SVector &v) const
{
	return SVector(
		y * v.z - v.y * z,
		z * v.x - v.z * x,
		x * v.y - v.x * y
	);
}

